/*
  Teachbot line following demo using
  two analog reflective sensors
*/

#include <Servo.h> 

Servo servoLeft;            // Define left servo
Servo servoRight;           // Define right servo
const int lineLSense = A2;
const int lineRSense = A3;
int irReflectL = 0;
int irReflectR = 0;
int thresh = 650;

void setup() { 
  servoLeft.attach(9); 
  servoRight.attach(10);
} 

void loop() { 

  // Read reflective sensors
  irReflectL = analogRead(lineLSense);  
  irReflectR = analogRead(lineRSense);

  if (irReflectL >= thresh && irReflectR >= thresh) {
    line_forward();   // on line
  }
  
  if (irReflectL >= thresh && irReflectR <= thresh) {
    line_spinLeft();  // veering off right
    delay(4);
  }
  
  if (irReflectL <= thresh && irReflectR >= thresh) {
    line_spinRight();  // veering off left
    delay(4);
  }

  // If line is lost try to reacquire
  if (irReflectL < thresh && irReflectR < thresh) {
    line_spinRight();
    delay(20);
  }
  
}

// Motion routines for line following
void line_forward() {
  servoLeft.write(180);
  servoRight.write(0);
}

void line_slipRight() {
  servoLeft.write(180);
  servoRight.write(90);
}
void line_slipLeft() {
  servoLeft.write(90);
  servoRight.write(0);
}
void line_spinRight() {
  servoLeft.write(180);
  servoRight.write(180);
}
void line_spinLeft() {
  servoLeft.write(0);
  servoRight.write(0);
}


